<template>
  <div class="camerasMg">
    <el-row class="topBar">
      <el-col>
        <el-form :inline="true" :model="searchData">
          <el-form-item label>
            <el-input v-model="searchData.exerciseName" placeholder="请输演练名称"></el-input>
          </el-form-item>
          <el-form-item label>
            <el-input v-model="searchData.exerciseType" placeholder="请输演练类型"></el-input>
          </el-form-item>
          <el-form-item>
            <el-button type="primary" @click="searchFun()">
              <i class="el-icon-search"></i> 搜索
            </el-button>
            <el-button type="primary" @click="resetFun()">
              <i class="el-icon-refresh"></i> 重置
            </el-button>
          </el-form-item>
          <el-form-item class="fr">
            <el-button plain type="primary" @click="addFun()">
              <i class="el-icon-plus"></i> 新增
            </el-button>
          </el-form-item>
        </el-form>
      </el-col>
    </el-row>
    <el-table :data="tableData.pageData" stripe border style="width:100%;" :loading="false">
      <el-table-column width="50" type="index" label="序号"></el-table-column>
      <el-table-column prop="exerciseName" label="演练名称"></el-table-column>
      <el-table-column prop="grade" label="演练等级">
        <template slot-scope="scope">
          <font>{{scope.row.grade}}</font>
        </template>
      </el-table-column>
      <el-table-column prop="exerciseType" label="演练类型"></el-table-column>
      <el-table-column prop="place" label="演练地点"></el-table-column>
      <el-table-column prop="startTime" label="开始时间"></el-table-column>
      <el-table-column prop="peopleNum" label="参演人数"></el-table-column>
      <el-table-column prop="exercisePurpose" label="演练目的" :show-overflow-tooltip="true"></el-table-column>
      <el-table-column label="操作" width="300" align="center">
        <template slot-scope="scope">
          <el-button @click="editFun(scope.row)" size="small">
            <i class="el-icon-edit-outline"></i> 编辑
          </el-button>
          <el-button type="danger" @click="delFun(scope.row)" size="small">
            <i class="el-icon-delete"></i> 删除
          </el-button>
        </template>
      </el-table-column>
    </el-table>
    <el-pagination
      background
      layout="total,sizes, prev, pager, next, jumper"
      :total="tableData.total"
      @size-change="handleSizeChange"
      @current-change="handleCurrentChange"
      :current-page="PAGE.page"
      :page-size="PAGE.size"
    ></el-pagination>
    <DrillMgEdit
      v-if="dialogVisible"
      :dialogVisible="dialogVisible"
      :editForm="formData"
      :title="dialogTit"
      @dialogFun="closeDialog"
      @refreshTableData="getTableData"
      :key="zjKey"
    ></DrillMgEdit>
  </div>
</template>
<script lang="ts">
import { Component, Vue, Provide } from "vue-property-decorator";
import DrillMgEdit from "./DrillMgEdit.vue";
import METHOD from "@/utils/methods";
@Component({
  components: { DrillMgEdit }
})
export default class DrillMg extends Vue {
  @Provide() signId: String = "";
  @Provide() tableData: Object = { pageData: [], total: 0 };
  @Provide() PAGE: any = { page: 1, size: 10 };
  @Provide() searchData: any = { exerciseName: "" ,exerciseType:''};
  @Provide() loading: Boolean = false;
  //编辑组件
  @Provide() dialogVisible: Boolean = false;
  @Provide() dialogTit: String = "新增";
  @Provide() formData: Object = {};
  @Provide() zjKey: any = 0;
  @Provide() reVisible: Boolean = false;
  @Provide() reId: String = "";
  getTableData() {
    let that = this,
      params = Object.assign(that.PAGE, that.searchData);
    (that as any).$axios
      .post("/exerciseInfo/getExerciseInfoList", params)
      .then((res: any) => {
        if( res ) that.tableData = res;
      });
  }
  searchFun() {
    this.PAGE = { page: 1, size: 10 };
    this.getTableData();
  }
  resetFun() {
    this.PAGE = { page: 1, size: 10 };
    this.searchData = { exerciseName: "" ,exerciseType:''};
    this.getTableData();
  }
  addFun() {
    this.zjKey++;
    this.dialogVisible = true;
  }
  editFun(row: any) {
    this.dialogTit = "编辑";
    this.formData = Object.assign({}, row);
    this.zjKey++;
    this.dialogVisible = true;
  }
  delFun(row: any) {
    let that = this as any;
    METHOD.deleteFun(that, `/exerciseInfo/delExerciseInfoById/${row.id}`, function() {
      that.getTableData();
    });
  }
  handleSizeChange(val: any) {
    this.PAGE.size = val;
    this.getTableData();
  }
  handleCurrentChange(val: any) {
    this.PAGE.page = val;
    this.getTableData();
  }
  closeDialog() {
    //关闭窗口
    this.dialogVisible = false;
    this.formData = {};
  }
  recloseDialog() {
    this.reVisible = false;
  }
  resoveFun(row: any){
    this.reVisible = true;
    this.formData = Object.assign({}, row);
  }
  created() {
    this.getTableData();
  }
}
</script>
